function [Y] = BVP(p,n,Ztemp)
global c

k = 10;
Z = linspace(0,c.Lchannel,k);

if isfield(p,'guess')
    A = pchip(Ztemp,p.guess',Z);
    Y0.y = [A(1,:).*A(3,:)*c.scaleF;                % n_c  -  mol/s
            flip(A(2,:).*flip(A(4,:))*c.scaleF);    % n_d  -  mol/s
            A(3,:)./c.Mw*c.scaleF;                  % n_wc -  mol/s
            flip(A(4,:))./c.Mw*c.scaleF;            % n_wd -  mol/s
            A(5,:);                                 % Tc - K
            flip(A(6,:))];                          % Td - K
    Y0.x = Z;
    Y0.solver = 'bvpinit';
    Y0.yinit  = [A(1,1)*A(3,1)*c.scaleF; 
                 A(2,1)*A(4,1)*c.scaleF; 
                 A(3,1)./c.Mw*c.scaleF; 
                 A(4,1)./c.Mw*c.scaleF;
                 A(5,1);
                 A(6,1)];
elseif length(p.m_c)>1
    Y0 = bvpinit(Z,[c.Fw*p.m_c(n)*c.scaleF;
                    c.Fw*p.m_d(n)*c.scaleF;
                    c.Fw./c.Mw*c.scaleF;
                    c.Fw./c.Mw*c.scaleF;
                    c.T;
                    c.T;]);
else
    Y0 = bvpinit(Z,[c.Fw*p.m_c(1)*c.scaleF;
                    c.Fw*p.m_d(1)*c.scaleF;
                    c.Fw./c.Mw*c.scaleF;
                    c.Fw./c.Mw*c.scaleF;
                    c.T;
                    c.T]);
end


%% Solver
AbsTol = 1e-9; RelTol = 1e-12;
Options = bvpset('RelTol',RelTol,'AbsTol',AbsTol, 'stats', 'on');
SOL = bvp4c(@(Z,Y)BVPODE(Z,Y,n),@(Ya,Yb)BVPBC(Ya,Yb,p,n),Y0,Options);

Y(7,:)=SOL.x;
Y(1,:)=SOL.y(1,:)./(SOL.y(3,:).*c.Mw); % mol/kg
Y(2,:)=SOL.y(2,:)./(SOL.y(4,:).*c.Mw); % mol/kg
Y(3,:)=SOL.y(3,:).*c.Mw./c.scaleF;   % kg/s
Y(4,:)=SOL.y(4,:).*c.Mw./c.scaleF;   % kg/s
Y(5,:)=SOL.y(5,:); % T
Y(6,:)=SOL.y(6,:); % T

end