function p = BVPResults(Y,n,p)
global c

p.m_c(n,:)  = Y(:,1)';
p.m_d(n,:)  = Y(:,2)';
p.F_wc(n,:) = Y(:,3)';
p.F_wd(n,:) = Y(:,4)';
p.n_c(n,:)  = p.m_c(n,:).*p.F_wc(n,:);
p.n_d(n,:)  = p.m_d(n,:).*p.F_wd(n,:);
p.n_wc(n,:) = p.F_wc(n,:)./c.Mw;
p.n_wd(n,:) = p.F_wd(n,:)./c.Mw;
p.T_c(n,:)  = Y(:,5)';
p.T_d(n,:)  = Y(:,6)';

% p.vv(n,:) = (p.F_wc(n,:)+p.n_c(n,:).*c.Mi(n))/(c.Wchannel*c.d*1e2)*10;

for i = 1:length(Y(:,1))
    temp = CALC_Eunit(p.m_c(n,i), p.m_d(n,i), (p.T_c(n,i)+p.T_d(n,i))./2);
    p.E_unit(n,i) = temp(n,1);  
    temp = CALC_Runit(p.m_c(n,i), p.m_d(n,i), (p.T_c(n,i)+p.T_d(n,i))./2);
    p.R_unit(n,i) = temp(n,1);
    if c.prodH2 == 1
        [temp1, temp2, temp3] = CALC_FH2(p.E_unit(n,i), p.R_unit(n,i), (p.T_c(n,i)+p.T_d(n,i))./2, p.m_c(n,i), p.m_d(n,i));
    else
        [temp1, temp2, temp3] = CALC_j(p.E_unit(n,i), p.R_unit(n,i), (p.T_c(n,i)+p.T_d(n,i))./2, p.m_c(n,i), p.m_d(n,i));
    end
    p.j_max(n,i) = temp1(n,1);
%     p.N_unit(n,i)= temp2(n,1);
    p.F_H2(n,i)  = temp3(n,1);

    [temp1, temp2, temp3, temp4] = CALC_Molarity(p.m_c(n,i), p.m_d(n,i));
    p.c_c(n,i)  = temp1(n,1);
    p.c_d(n,i)  = temp2(n,1);
    p.c_wc(n,i) = temp3(n,1);
    p.c_wd(n,i) = temp4(n,1);
    [temp1, temp2] = CALC_Fluxes(p.j_max(n,i), p.c_c(n,i), p.c_d(n,i), p.c_wc(n,i), p.c_wd(n,i)); % Net flux into one high conc compartment
    p.Js(n,i) = temp1;
    p.JsDiff(n,i) = - 2.*c.De.*(p.c_c(n,i)-p.c_d(n,i))./c.dm; % mol/m2 s
    p.JsEl(n,i)   = -(2.*c.t_e).*p.j_max(n,i)./c.F;
    p.Jw(n,i) = temp2;
    p.JwDiff(n,i) = - 2.*c.Dw.*(p.c_wc(n,i)-p.c_wd(n,i))./c.dm; % mol/m2 s
    p.JwEl(n,i)   = -(2.*c.t_w).*p.j_max(n,i)./c.F; % mol/m2 s
    p.Jq(n,i) = 2.*c.U.*(p.T_c(n,i) - p.T_d(n,i)); % W/m2

    [temp1, temp2] = CALC_Hbar(p.m_c(n,i), p.T_c(n,i));
    p.hsc(n,i) = temp1(n,1);
    p.hwc(n,i) = temp2(n,1);
    [temp1, temp2] = CALC_Hbar(p.m_d(n,i), p.T_d(n,i));
    p.hsd(n,i) = temp1(n,1);
    p.hwd(n,i) = temp2(n,1);
    
    Hmixd = CALC_Hmix(p.m_d(n,i), p.T_d(n,i));
    Hmixc = CALC_Hmix(p.m_c(n,i), p.T_c(n,i));    
    p.xsc(n,i) = p.n_c(n,i)./(p.n_c(n,i)+p.n_wc(n,i)); 
    p.xsd(n,i) = p.n_d(n,i)./(p.n_d(n,i)+p.n_wd(n,i));
    p.Mc(n,i) = (p.xsc(n,i).*c.Mi(n)+(1-p.xsc(n,i)).*c.Mw);
    p.Md(n,i) = (p.xsd(n,i).*c.Mi(n)+(1-p.xsd(n,i)).*c.Mw);
    Hmixnd = Hmixd(n,1).*p.m_d(n,i);   % J 
    p.Hd(n,i)  = (c.H0f(n)*p.m_d(n,i) + c.H0fw/c.Mw + Hmixnd)./(p.m_d(n,i)+1/c.Mw)./p.Md(n,i); % J/kg
    Hmixnc = Hmixc(n,1).*p.m_c(n,i);   % J 
    p.Hc(n,i)  = (c.H0f(n)*p.m_c(n,i) + c.H0fw/c.Mw + Hmixnc)./(p.m_c(n,i)+1/c.Mw)./p.Mc(n,i);
    
    temp1 = CALC_Cp(p.m_c(n,i), p.T_c(n,i))./p.Mc(n,i); % J/K kg mixture
    temp2 = CALC_Cp(p.m_d(n,i), p.T_d(n,i))./p.Md(n,i); % J/K kg
    p.Cpc(n,i) = temp1(n,1);
    p.Cpd(n,i) = temp2(n,1);
end

p.j(n,:) = trapz(p.Z,p.j_max(n,:))./c.Lchannel;
p.E(n,:) = trapz(p.Z,p.E_unit(n,:))./c.Lchannel;
p.R(n,:) = trapz(p.Z,p.R_unit(n,:))./c.Lchannel;
p.H2(n,:) = trapz(p.Z,p.F_H2(n,:))./c.Lchannel;
temp = CALC_Nunit(p.j(n,:), p.E(n,:), p.R(n,:), (p.T_c(n,i)+p.T_d(n,i))./2);
p.N_unit(n,:) = ceil(temp(n,1))+1;

%% Energy balance for a unit cell
p.dFHc(n,:) = -c.Wchannel.*(trapz(p.Z,p.Jq(n,:))  + trapz(p.Z, p.hwd(n,:).*p.Jw(n,:)  + p.hsc(n,:).*p.Js(n,:) )); % W
p.dFHd(n,:) = -c.Wchannel.*(trapz(p.Z,-p.Jq(n,:)) + trapz(p.Z, p.hwd(n,:).*-p.Jw(n,:) + p.hsc(n,:).*-p.Js(n,:)) );  % W
p.dH(n,:)   = p.dFHc(n,:) + p.dFHd(n,:);




%% Energy balance
Fc = (p.n_c(n,:)+p.n_wc(n,:)).*p.Mc(n,:).*(p.N_unit(n,:));
Fd = (p.n_d(n,:)+p.n_wd(n,:)).*p.Md(n,:).*(p.N_unit(n,:));
p.dFHc2(n,:) = trapz(Fc, p.Hc(n,:)) + trapz(p.T_c(n,:), Fc.*p.Cpc(n,:)) + trapz(p.xsc(n,:)./p.Mc(n,:).*c.Mi(n), Fc.*p.hsc(n,:)./c.Mi(n)) + trapz((1-p.xsc(n,:))./p.Mc(n,:).*c.Mw, Fc.*p.hwc(n,:)./c.Mw);
p.dFHd2(n,:) = trapz(Fd, p.Hd(n,:)) + trapz(p.T_d(n,:), Fd.*p.Cpd(n,:)) + trapz(p.xsd(n,:)./p.Md(n,:).*c.Mi(n), Fd.*p.hsd(n,:)./c.Mi(n)) + trapz((1-p.xsd(n,:))./p.Md(n,:).*c.Mw, Fd.*p.hwd(n,:)./c.Mw);
p.dFH(n,:)   = p.dFHc2(n,:) - p.dFHd2(n,:);

p.dFHc3(n,:) = trapz(p.Z, Fc.*p.Hc(n,:));
p.dFHd3(n,:) = trapz(p.Z, Fd.*p.Hd(n,:));
p.dFH3(n,:)  = p.dFHc3(n,:) - p.dFHd3(n,:);

p.dFHc4(n,:) = Fc(1).*p.Hc(n,1)-Fc(end).*p.Hc(n,end);
p.dFHd4(n,:) = Fd(end).*p.Hd(n,end) - Fd(1).*p.Hd(n,1);
p.dFH4(n,:)  = p.dFHc4(n,:) + p.dFHd4(n,:);

end

