function Cp = CALC_Cp(m,T)
global c

a = 1.2;
b = 2;
[~, ~, AJ] = CALC_Aphi(T);

% 1 kg water basis
xe = m./(m+c.Mw^-1);
xw = c.Mw^-1./(m+c.Mw^-1);

A = 2.*c.R.*T.^2.*c.bJ(:,1);
B = c.R.*T.^2.*c.bJ(:,2);
C = 2.*c.R.*T.^2.*c.bJ(:,3);
g = (1-(1+b*sqrt(m)).*exp(-b*sqrt(m)));

phi_Cp = c.Cp0 + AJ./a.*log(1+1.2.*sqrt(m)) - A.*m - B.*g - C.*m.^2;

Cp = phi_Cp.*xe + c.Cpw0.*xw; % J/Kmol 

end

