function [Hs, Hw] = CALC_Hbar(m, T)
global c


nn = 100;
mm = linspace(0,m,nn);
ntot = (mm + 1./c.Mw);
xm   = mm./ntot;
    
% Hmix = CALC_dHmix(mm,T);  % Mixing enthalpy per mol salt
for i = 1:nn
    % 1 kg water basis
    Hmix(:,i) = CALC_Hmix(mm(:,i),T);  % Mixing enthalpy per mol salt
    Hmixn(:,i) = Hmix(:,i).*mm(:,i);   % J (extensive)
    Hmixnn(:,i) = Hmix(:,i)./ntot(:,i);% J/mol
    H(:,i)  = c.H0f*mm(:,i) + c.H0fw/c.Mw + Hmixn(:,i); % J
%     Hm2(:,i) = c.H0f*xm(:,i) + c.H0fw*(1-xm(:,1)) + Hmixnn(:,i);
    Hm(:,i) = H(:,i)./ntot(:,i); % J/mol
end
for j = 1:length(c.Mi)
    dHdx = dss020(xm(1,1),xm(1,end),nn,Hm(j,:),1);
end

Hs = Hm + (1-xm).*dHdx;
Hw = Hm - xm.*dHdx;

Hs = Hs(:,end);
Hw = Hw(:,end);


% Test
a = 1.2;
alpha = 2;
[~, AH, ~] = CALC_Aphi(T);
dgdT = AH./(6.*c.R.*T.^2).*(sqrt(m)./(1 + a.*sqrt(m)) + 2./a.*log(1+a.*sqrt(m)))...
        + m.*(2.*c.bL(:,1) + 2./(alpha.^2.*m).*c.bL(:,2).*(1 - (1+alpha.*sqrt(m)-alpha.^2.*m./2).*exp(-alpha*sqrt(m))))...
        + 3.*m.^2./2.*c.bL(:,3);
He = c.H0f - 2.*c.R.*T.^2.*dgdT;    
    

end

