function Hvap = CALC_Hvap(m,T)
global c


% [Ss, Sw] = CALC_Sbar(m, T);
%  Sg = c.S0fw + c.Hevap.*c.Mw./T + c.Cpwg*log(T/(273.15+100)) - c.R.*T.*log(c.Pevap/1);

% Ge & Wang, https://doi.org/10.1021/ie801348c
a1 = -7.76451;
a2 = 1.45838;
a3 = -2.77580;
a4 = -1.23303;
Tc = 647.3;
tau = 1 - T./Tc; 

dp0dT = -Tc./T.^2.*(a1.*tau + a2.*tau.^(3/2) + a3.*tau.^3 + a4.*tau.^6)...
      - 1./T.*( a1 + 1.5.*a2.*tau.^(1/2) + 3.*a3.*tau.^2 + 6.*a4.*tau.^5);

a = 1.2;
alpha = 2;
[~, AH, ~] = CALC_Aphi(T);
f_phi = -(AH./(6.*c.R.*T.^2)).*sqrt(m)./(1 + a.*sqrt(m));
B_phi = c.bL(:,1) + c.bL(:,2).*exp(-alpha*sqrt(m));
dphidT = f_phi + m.*B_phi + m.^2.*c.bL(:,3);


Hvap = c.R.*T.^2.*(dp0dT + 2.*m.*c.Mw.*dphidT)./c.Mw; % J/kg
end 