function [Ss, Sw] = CALC_Sbar(m, T)
global c


nn = 100;
mm = linspace(1e-6,m,nn);
ntot = (mm + 1./c.Mw);
xm   = mm./ntot;
    
% Hmix = CALC_dHmix(mm,T);  % Mixing enthalpy per mol salt
for i = 1:nn
    [gamma(:,i),phi(:,i)] = CALC_gamma(mm(:,i),T);

    % 1 kg water basis
    Gex(:,i)    = 2*mm(:,i).*c.R.*T.*(log(gamma(:,i)) + 1 - phi(:,1)); % J 
    Hmix(:,i) = CALC_Hmix(mm(:,i),T);  % Mixing enthalpy per mol salt
    Hmixn(:,i) = Hmix(:,i).*mm(:,i);   % J (extensive)
    Hmixnn(:,i) = Hmix(:,i)./ntot(:,i);% J/mol
    H(:,i)  = c.H0f*mm(:,i) + c.H0fw/c.Mw + Hmixn(:,i); % J
%     Hm2(:,i) = c.H0f*xm(:,i) + c.H0fw*(1-xm(:,1)) + Hmixnn(:,i);
    Hm(:,i) = H(:,i)./ntot(:,i); % J/mol
    
    Smix = -(Gex-Hmixn)./T;
    S(:,i) = c.S0f*mm(:,i) + c.S0fw/c.Mw + Smix(:,i); % J
    Sm(:,i) = S(:,i)./ntot(:,i); % J/Kmol
end
for j = 1:length(c.Mi)
    dHdx = dss020(xm(1,1),xm(1,end),nn,Hm(j,:),1);
    dSdx = dss020(xm(1,1),xm(1,end),nn,Sm(j,:),1);
end

Hs = Hm + (1-xm).*dHdx;
Hw = Hm - xm.*dHdx;

Ss = Sm + (1-xm).*dSdx;
Sw = Sm - xm.*dSdx;

Hs = Hs(:,end);
Hw = Hw(:,end);

Ss = Ss(:,end);
Sw = Sw(:,end);
end

