function Y = IVP(p,n,Z)
global c

%% Initial vars.
if length(p.m_c)>1
    Y0 = [c.Fw*p.m_c(n).*c.scaleF, c.Fw*p.m_d(n).*c.scaleF, c.Fw./c.Mw.*c.scaleF, c.Fw./c.Mw.*c.scaleF, c.T, c.T]; % mol/s, K
else
    Y0 = [(c.Fw*p.m_c(1)).*c.scaleF, (c.Fw*p.m_d(1)).*c.scaleF, (c.Fw./c.Mw).*c.scaleF, (c.Fw./c.Mw).*c.scaleF, c.T, c.T];
end

%% Solver
AbsTol = 1e-11; RelTol = 1e-11;
Options = odeset('RelTol',RelTol,'AbsTol',AbsTol);
[Z,Yf] = ode15s(@(Z,Y)DIFF(Z,Y,n),Z,Y0,Options);

Y(:,1)=Yf(:,1)./(Yf(:,3).*c.Mw); % mol/kg
Y(:,2)=Yf(:,2)./(Yf(:,4).*c.Mw); % mol/kg
Y(:,3)=Yf(:,3).*c.Mw./c.scaleF; % kg/s water
Y(:,4)=Yf(:,4).*c.Mw./c.scaleF; % kg/s water
Y(:,5)=Yf(:,5); % Temperature K
Y(:,6)=Yf(:,6); % Temperature K
end