function p = IVPResults(Y,n,p)
global c

p.m_c(n,:)  = Y(:,1)';
p.m_d(n,:)  = Y(:,2)';
p.F_wc(n,:) = Y(:,3)';
p.F_wd(n,:) = Y(:,4)';
p.n_c(n,:)  = p.m_c(n,:).*p.F_wc(n,:);
p.n_d(n,:)  = p.m_d(n,:).*p.F_wd(n,:);
p.n_wc(n,:) = p.F_wc(n,:)./c.Mw;
p.n_wd(n,:) = p.F_wd(n,:)./c.Mw;
p.T_c(n,:)  = Y(:,5)';
p.T_d(n,:)  = Y(:,6)';

% p.vv(n,:) = (p.F_wc(n,:)+p.n_c(n,:).*c.Mi(n))/(c.Wchannel*c.d*1e2)*10;

for i = 1:length(Y(:,1))
    temp = CALC_Eunit(p.m_c(n,i), p.m_d(n,i), (p.T_c(n,i)+p.T_d(n,i))./2);
    p.E_unit(n,i) = temp(n,1);  
    temp = CALC_Runit(p.m_c(n,i), p.m_d(n,i), (p.T_c(n,i)+p.T_d(n,i))./2);
    p.R_unit(n,i) = temp(n,1);
    [temp1, temp2, temp3] = CALC_FH2(p.E_unit(n,i), p.R_unit(n,i), (p.T_c(n,i)+p.T_d(n,i))./2, p.m_c(n,i), p.m_d(n,i));
    p.j_max(n,i) = temp1(n,1);
%     p.N_unit(n,i)= temp2(n,1);
    p.F_H2(n,i)  = temp3(n,1);

    [temp1, temp2, temp3, temp4] = CALC_Molarity(p.m_c(n,i), p.m_d(n,i));
    p.c_c(n,i)  = temp1(n,1);
    p.c_d(n,i)  = temp2(n,1);
    p.c_wc(n,i) = temp3(n,1);
    p.c_wd(n,i) = temp4(n,1);
    [temp1, temp2] = CALC_Fluxes(p.j_max(n,i), p.c_c(n,i), p.c_d(n,i), p.c_wc(n,i), p.c_wd(n,i)); % Net flux into one high conc compartment
    p.Js(n,i) = temp1;
    p.Jw(n,i) = temp2;
    p.Jq(n,i) = 2.*c.U.*(p.T_c(n,i) - p.T_d(n,i)); % W/m2

    [temp1, temp2] = CALC_Hbar(p.m_c(n,i), p.T_c(n,i));
    p.hsc(n,i) = temp1(n,1);
    p.hwc(n,i) = temp2(n,1);
    [temp1, temp2] = CALC_Hbar(p.m_d(n,i), p.T_d(n,i));
    p.hsd(n,i) = temp1(n,1);
    p.hwd(n,i) = temp2(n,1);
    
    Hmixd = CALC_Hmix(p.m_d(n,i), p.T_d(n,i));
    Hmixc = CALC_Hmix(p.m_c(n,i), p.T_c(n,i));    
    p.xsc(n,i) = p.n_c(n,i)./(p.n_c(n,i)+p.n_wc(n,i)); 
    p.xsd(n,i) = p.n_d(n,i)./(p.n_d(n,i)+p.n_wd(n,i));
    p.Mc(n,i) = (p.xsc(n,i).*c.Mi(n)+(1-p.xsc(n,i)).*c.Mw);
    p.Md(n,i) = (p.xsd(n,i).*c.Mi(n)+(1-p.xsd(n,i)).*c.Mw);
    Hmixnd = Hmixd(n,1).*p.m_d(n,i);   % J 
    p.Hd(n,i)  = (c.H0f(n)*p.m_d(n,i) + c.H0fw/c.Mw + Hmixnd)./(p.m_d(n,i)+1/c.Mw)./p.Md(n,i); % J/kg
    Hmixnc = Hmixc(n,1).*p.m_c(n,i);   % J 
    p.Hc(n,i)  = (c.H0f(n)*p.m_c(n,i) + c.H0fw/c.Mw + Hmixnc)./(p.m_c(n,i)+1/c.Mw)./p.Mc(n,i);
    
    

    temp1 = CALC_Cp(p.m_c(n,i), p.T_c(n,i))./p.Mc(n,i); % J/K kg mixture
    temp2 = CALC_Cp(p.m_d(n,i), p.T_d(n,i))./p.Md(n,i); % J/K kg
    p.Cpc(n,i) = temp1(n,1);
    p.Cpd(n,i) = temp2(n,1);
end

p.j(n,:) = mean(p.j_max(n,:));
p.E(n,:) = mean(p.E_unit(n,:));
p.R(n,:) = mean(p.R_unit(n,:));
temp = CALC_Nunit(p.j(n,:), p.E(n,:), p.R(n,:), (p.T_c(n,i)+p.T_d(n,i))./2);
p.N_unit(n,:) = ceil(temp(n,1));

%% Energy balance for a unit cell
p.dFHc(n,:) = -c.Wchannel.*(trapz(p.Z,p.Jq(n,:))  + trapz(p.Z, p.hwd(n,:).*p.Jw(n,:)  + p.hsc(n,:).*p.Js(n,:) )); % W
p.dFHd(n,:) = -c.Wchannel.*(trapz(p.Z,-p.Jq(n,:)) + trapz(p.Z, p.hwd(n,:).*-p.Jw(n,:) + p.hsc(n,:).*-p.Js(n,:) ));  % W
p.dH(n,:)   = p.dFHc(n,:) + p.dFHd(n,:);


%% Test 2
Fc = (p.n_c(n,:)+p.n_wc(n,:)).*p.Mc(n,:).*(p.N_unit(n,:)+1);
Fd = (p.n_d(n,:)+p.n_wd(n,:)).*p.Md(n,:).*(p.N_unit(n,:)+1);
p.Ftotc = (p.n_c(n,:)+p.n_wc(n,:)).*p.Mc(n,:).*(p.N_unit(n,:)+1);
p.Ftotd = (p.n_d(n,:)+p.n_wd(n,:)).*p.Md(n,:).*(p.N_unit(n,:)+1);
% p.dFHc3(n,:) = trapz(Fc, (p.xsc(n,:).*p.hsc(n,:) + (1-p.xsc(n,:)).*p.hwc(n,:))./p.Mc(n,:) ) + trapz(p.T_c(n,:), Fc.*p.Cpc(n,:)) + trapz(p.xsc(n,:)./p.Mc(n,:).*c.Mi(n), Fc.*p.hsc(n,:)./c.Mi(n)) + trapz((1-p.xsc(n,:))./p.Mc(n,:).*c.Mw, Fc.*p.hwc(n,:)./c.Mw);
% p.dFHd3(n,:) = trapz(Fd, (p.xsd(n,:).*p.hsd(n,:) + (1-p.xsd(n,:)).*p.hwd(n,:))./p.Md(n,:) ) + trapz(p.T_d(n,:), Fd.*p.Cpd(n,:)) + trapz(p.xsd(n,:)./p.Md(n,:).*c.Mi(n), Fd.*p.hsd(n,:)./c.Mi(n)) + trapz((1-p.xsd(n,:))./p.Md(n,:).*c.Mw, Fd.*p.hwd(n,:)./c.Mw);
p.dFHc2(n,:) = trapz(Fc, p.Hc(n,:)) + trapz(p.T_c(n,:), Fc.*p.Cpc(n,:)) + trapz(p.xsc(n,:)./p.Mc(n,:).*c.Mi(n), Fc.*p.hsc(n,:)./c.Mi(n)) + trapz((1-p.xsc(n,:))./p.Mc(n,:).*c.Mw, Fc.*p.hwc(n,:)./c.Mw);
p.dFHd2(n,:) = trapz(Fd, p.Hd(n,:)) + trapz(p.T_d(n,:), Fd.*p.Cpd(n,:)) + trapz(p.xsd(n,:)./p.Md(n,:).*c.Mi(n), Fd.*p.hsd(n,:)./c.Mi(n)) + trapz((1-p.xsd(n,:))./p.Md(n,:).*c.Mw, Fd.*p.hwd(n,:)./c.Mw);
p.dFH(n,:) = p.dFHc2(n,:)+p.dFHd2(n,:);

% dTc(n,:) = dss020(p.Z(1),p.Z(end),100, p.T_c(n,:), 1);
% dTd(n,:) = dss020(p.Z(1),p.Z(end),100, p.T_d(n,:), 1);
% dwsc(n,:) = dss020(p.Z(1),p.Z(end),100, p.xsc(n,:)./p.Mc(n,:).*c.Mi(n), 1);
% dwsd(n,:) = dss020(p.Z(1),p.Z(end),100, p.xsd(n,:)./p.Md(n,:).*c.Mi(n), 1);
% dwwc(n,:) = dss020(p.Z(1),p.Z(end),100, (1-p.xsc(n,:))./p.Mc(n,:).*c.Mw, 1);
% dwwd(n,:) = dss020(p.Z(1),p.Z(end),100, (1-p.xsd(n,:))./p.Md(n,:).*c.Mw, 1);
% 
% testc = p.Cpc(n,:).*dTc(n,:) + p.hsc(n,:)./c.Mi(n).*dwsc(n,:) + p.hwc(n,:)./c.Mw.*dwwc(n,:);
% testd = p.Cpd(n,:).*dTd(n,:) + p.hsd(n,:)./c.Mi(n).*dwsd(n,:) + p.hwd(n,:)./c.Mw.*dwwd(n,:);
% (trapz(p.Z, testc) + trapz(p.Z, testd)).*(Fc(1)+Fd(1))
end

