function [C, Ceq] = SlurryCon(X,precip)
global c

ncin = precip.N_unit(precip.i).*precip.m_c(precip.i).*c.Fw;
ncout = precip.N_unit(precip.i).*precip.m_cout(precip.i).*precip.Fwcout(precip.i);

% Fw2 = (ncin-ncout-precip.N_unit(precip.i).*precip.m_cout(precip.i).*(c.Fw-precip.Fwcout(precip.i)))./(X-precip.m_cout(precip.i));
% Fw1 = Fw2 - precip.N_unit(precip.i).*(c.Fw-precip.Fwcout(precip.i));

Fw1 = (ncin-ncout-X.*precip.N_unit(precip.i).*(c.Fw-precip.Fwcout(precip.i)))./(X-precip.m_cout(precip.i));
Fw2 = Fw1 + precip.N_unit(precip.i).*(c.Fw-precip.Fwcout(precip.i));

H = (Fw2.*X.*c.Mi).*abs(c.Hsol)./c.Mi.*1e3 + ...
    (Fw2.*X.*c.Mi + Fw2).*c.Cpw.*3600*(c.T-c.Tl);

nFw1 = Fw1.*precip.m_cout(precip.i);
nFw2 = Fw2.*X;

%% Equality contraints
Ceq = [-(Fw1 - Fw2 + precip.N_unit(precip.i).*(c.Fw-precip.Fwcout(precip.i)));
       (ncin - ncout + nFw1 - nFw2)]; 

%% Inequality constraints
C = [nFw1 - ncout;
     (Fw2-c.Fw.*precip.N_unit(precip.i))*1e6;
     (Fw1-c.Fw.*precip.N_unit(precip.i))*1e6;
     -H(precip.i).*3600]; % <=0

end