global c
clear all
Parameters;
ks = 100; % Resolution
ns = 1; % Salt number
Z = linspace(0,c.Lchannel,ks); pIVP.Z = Z; pBVP.Z = Z;
% init.m_c = 2*ones(length(c.Mi),1); 
% init.m_d = 0.1*ones(length(c.Mi),1);
% precip.m_c = c.S40(7); 
% precip.m_d = c.S10(7);

m = linspace(0.1,4.5,20);
[Xm1,Ym1]=meshgrid(m,m-0.09);
% tw = linspace(0,10,11);
% [Xm,Ytw]=meshgrid(m,tw);


%% 
for i=1:length(m)
for j=1:length(m)
    if i<=j
init.m_c = Xm1(i,j)*ones(length(c.Mi),1);
init.m_d = Ym1(i,j)*ones(length(c.Mi),1);
% c.t_w = Ytw(i,j);
    

%% COUNTER-CURRENT FLOW
for n = 1:length(c.Mi)
%     if n == 7
        Y = IVP(init, n, pIVP.Z);       % Solve co-current flow initial value problem
        pIVP = IVPResults(Y, n, pIVP);    % Results from co-current flow
        init.guess = Y;                 % Co-current flow used as initial guess for the boundary value problem    
        Y = BVP(init, n, pIVP.Z)';      % Solve counter-current boundary value problem
        Y = pchip(Y(:,7), Y', Z)';        
        pBVP = BVPResults(Y, n, pBVP);    % Results from counter-current flow
%     else % Added to speed up for nonrelevant salts
%         Y = [c.Fw.*1.*ones(ks,1) c.Fw.*0.1.*ones(ks,1) c.Fw./c.Mw.*ones(ks,2) ones(ks,2).*c.T Z'];     
%         pBVP = BVPResults(Y, n, pBVP);    % Results from counter-current flow
%     end
end
clear n Y init
pBVP.precip = precipRegen(pBVP); %% Precipitation regeneration
pBVP.evap   = evapRegen(pBVP); %% Evaporation regeneration

%%
FH2(i,j) = pBVP.H2(ns,1);
FH2Q(i,j) =  (pBVP.evap.Q(ns,1)./1000)./(FH2(i,j)*1e3*3600);
MED(i,j)  = 40000.*pBVP.evap.Ftot(1,4)./1.*1e-3.*3600; % W
P(i,j)    = pBVP.N_unit(ns,1).*pBVP.j(ns,1).*(pBVP.E(ns,1) - pBVP.R(ns,1).*pBVP.j(ns,1));
eta1(i,j) = P(i,j).*c.Am./MED(i,j);


r_d = 1./(CALC_Conductivity(Ym1(i,j), c.T));
r_c = 1./(CALC_Conductivity(Xm1(i,j), c.T));
Rd(i,j) = c.IEMbeta.*c.d.*r_d(ns,1);
Rc(i,j) = c.IEMbeta.*c.d.*r_c(ns,1);
R_unit(i,j) = c.IEMbeta.*c.d.*(r_c(ns,1) + r_d(ns,1)) + (c.R_CEM + c.R_AEM);
E = CALC_Eunit(Xm1(i,j), Ym1(i,j), c.T);
E_unit(i,j) = E(ns,1);
    else
        FH2Q(i,j) =  FH2Q(j,i);
        MED(i,j) = MED(j,i);
        P(i,j) = P(j,i);
        eta1(i,j) = eta1(j,i);
        FH2(i,j) = FH2(j,i);
        Rd(i,j) = Rd(j,i);
        Rc(i,j) = Rc(j,i);
        R_unit(i,j) = R_unit(j,i);
        E_unit(i,j) = E_unit(j,i);
    end
end

end


%% Contour
m2 = linspace(m(1),m(end),1000);
[Xm2,Ym2]=meshgrid(m2,m2-0.09);
E = interp2(Xm1,Ym1,E_unit,Xm2,Ym2);
eta12 = interp2(Xm1,Ym1,eta1,Xm2,Ym2);
R = interp2(Xm1,Ym1,R_unit,Xm2,Ym2);
FHyd = interp2(Xm1,Ym1,FH2,Xm2,Ym2);
FHydQ = interp2(Xm1,Ym1,FH2Q,Xm2,Ym2);

%% 
for i=1:length(m2)
for j=1:length(m2)
    if i>=j
        eta12(i,j) = NaN;
        FHyd(i,j) = NaN;
    end
end
end

cm1 = [121 162 206]./255;
% cm3 = [243 233 222]./255;
cm3 = [253 243 232]./255;
cm2 = ceil([linspace(cm1(1),cm3(1),20)' linspace(cm1(2),cm3(2),20)' linspace(cm1(3),cm3(3),20)'].*255)./255;


%% Heat per H2
% figure(1)
% [~,k]=contourf(log10(Xm2),log10(Ym2),FHydQ,500,'ShowText','on'); hold on
% xticks([-2 log10(0.02:0.01:0.09) -1 log10(0.2:0.1:0.9) 0 0.3])
% yticks([-2 log10(0.02:0.01:0.09) -1 log10(0.2:0.1:0.9) 0 0.3])
% xticklabels({'0.01','','','','','','','','','0.1','','','','','','','','','1','2'});
% yticklabels({'0.01','','','','','','','','','0.1','','','','','','','','','1','2'});
% xlim([log10(0.1) log10(3.5)])
% ylim([log10(0.01) log10(3.5)])
% 
% xlabel('$m_2$   /   mol kg$^{-1}$','Interpreter','latex')
% ylabel('$m_1$   /   mol kg$^{-1}$','Interpreter','latex')
% k.EdgeColor = 'none';
% kc = colorbar('Direction','reverse');
% set(gca,'ColorScale','log')
% kc.Label.String = '$Q_{H_2}$   /   kWh m$^{-2}$g$^{-1}_{H_2}$';
% kc.Label.Interpreter = 'latex';
% kc.Ticks = [5 10 50 100];
% [~,k2]=contour(log10(Xm2),log10(Ym2),FHydQ,[FHydQ(100,1000),FHydQ(10,1000),FHydQ(230,1000)],'k','ShowText','on','LineWidth',1);
% k2.LevelList = round(k2.LevelList,1);
% % [~,k3]=contour(log10(Xm2),log10(Ym2),FHydQ,[FHydQ(1,400),FHydQ(1,100)],'k','ShowText','on','LineWidth',0.8);
% % k3.LevelList = round(k3.LevelList,2);
% set(gca,'FontName','Arial','FontSize',18,'linewidth',1.2);
% set(gcf,'Position', [0 0 800 720]);
% colormap([cm1; cm2; cm3]);

%% Hydrogen prod
figure(2)
[~,k]=contourf(log10(Xm2),log10(Ym2),FHyd.*1e3.*3600,30,'ShowText','on'); hold on
xticks([-2 log10(0.02:0.01:0.09) -1 log10(0.2:0.1:0.9) 0 log10(2:1:4)])
yticks([-2 log10(0.02:0.01:0.09) -1 log10(0.2:0.1:0.9) 0 log10(2:1:4)])
xticklabels({'0.01','','','','','','','','','0.1','','','','0.5','','','','','1','2','3','4'});
yticklabels({'0.01','','','','','','','','','0.1','','','','0.5','','','','','1','2','3','4'});
xlim([log10(0.4) log10(m(end))])
ylim([log10(0.01) log10(4.5)])
xlabel('$m_2$   /   mol kg$^{-1}$','Interpreter','latex')
ylabel('$m_1$   /   mol kg$^{-1}$','Interpreter','latex')
k.EdgeColor = 'none';
kc = colorbar('Direction','reverse');
set(gca,'ColorScale','log')
kc.Label.String = '$F_{H_2}$  /  g m$^{-2}$h$^{-1}$';
kc.Label.Interpreter = 'latex';
kc.Ticks = [0.05 0.1 0.2 0.3 0.4];
[M2,k2]=contour(log10(Xm2),log10(Ym2),FHyd.*1e3.*3600,[FHyd(25,950).*1e3.*3600, FHyd(25,950).*1e3.*3600],'k','ShowText','on','LineWidth',1.2);
k2.LevelList = round(k2.LevelList,2); 
[M3,k3]=contour(log10(Xm2),log10(Ym2),FHyd.*1e3.*3600,[FHyd(1,400).*1e3.*3600, FHyd(1,50).*1e3.*3600],'k','ShowText','on','LineWidth',1.2);
k3.LevelList = round(k3.LevelList,2);
set(gca,'FontName','Arial','FontSize',18,'linewidth',1.2);
set(gcf,'Position', [0 0 800 720]);
colormap([cm1; cm2; cm3]);

%% Efficiency

figure(3)
[~,k]=contourf(log10(Xm2),log10(Ym2),eta12.*100,30,'ShowText','on'); hold on
xticks([-2 log10(0.02:0.01:0.09) -1 log10(0.2:0.1:0.9) 0 log10(2:1:4)])
yticks([-2 log10(0.02:0.01:0.09) -1 log10(0.2:0.1:0.9) 0 log10(2:1:4)])
xticklabels({'0.01','','','','','','','','','0.1','','','','0.5','','','','','1','2','3','4'});
yticklabels({'0.01','','','','','','','','','0.1','','','','0.5','','','','','1','2','3','4'});
% xlim([log10(m(1)) log10(m(end))])
xlim([log10(0.4) log10(m(end))])
ylim([log10(0.01) log10(4.5)])
xlabel('$m_2$   /   mol kg$^{-1}$','Interpreter','latex')
ylabel('$m_1$   /   mol kg$^{-1}$','Interpreter','latex')
k.EdgeColor = 'none';
kc = colorbar('Direction','reverse');
set(gca,'ColorScale','log')
kc.Label.String = '$\eta_I$  /  ${\%}$';
kc.Label.Interpreter = 'latex';
kc.Ticks = [0.05 0.1 0.5 1 2];
[M2,k2]=contour(log10(Xm2),log10(Ym2),eta12.*100,[eta12(100,950).*100,eta12(100,250).*100],'k','ShowText','on','LineWidth',1.2);
k2.LevelList = round(k2.LevelList,2); 
[M3,k3]=contour(log10(Xm2),log10(Ym2),eta12.*100,[eta12(15,1000).*100,eta12(15,1000).*100],'k','ShowText','on','LineWidth',1.2);
k3.LevelList = round(k3.LevelList,2);
set(gca,'FontName','Arial','FontSize',18,'linewidth',1.2);
set(gcf,'Position', [0 0 800 720]);
colormap([cm1; cm2; cm3]);

%% SAVE
cd C:\PhD\HeatToH2\Figures\ModelPaper\Graphs
exportgraphics(gcf,'FH2_Contour.png','Resolution',300)
cd C:\MATLAB\Heat2H2


%% Conductivity
figure(4)
kappa = interp1(m,1./(Rc(:,1)./c.IEMbeta./c.d),m2);
semilogx(m2,kappa,'-k','LineWidth',2); hold on
% plot(m2,kappa,'-k','LineWidth',2); hold on
xlabel('$m_e$   /   mol kg$^{-1}$','Interpreter','latex')
ylabel('$\kappa$   /   S m$^{-1}$','Interpreter','latex')
xticklabels({'0.01','0.1','1',});
kap = [0.007387	0.014688	0.07174	0.1412	0.27654	0.6665	1.289	6.9	13.59	20.2	26.77	28.1];
wkap = [0.003738435	0.007476731	0.037378134	0.074742466	0.149429753	0.37316115	0.74494891	5	10	15	20	21]./100;
mkap = wkap./c.Mi(ns)./(1-wkap.*1);
scatter(mkap,kap,125,'x','k','LineWidth',1.6)
set(gca,'FontName','Arial','FontSize',18,'linewidth',1.2);
set(gcf,'Position', [0 0 800 720]);




%% Graphs
% plot(Z./Z(end),pIVP.T_c(ns,:),'-r','Linewidth',1.2); hold on
% plot(Z./Z(end),pIVP.T_d(ns,:),'-b','Linewidth',1.2)
% 
% plot(Z./Z(end),pBVP.T_c(ns,:),'--r','Linewidth',1.2); hold on
% plot(Z./Z(end),pBVP.T_d(ns,:),'--b','Linewidth',1.2)

% figure(2)
% plot(Z./Z(end),c.Wchannel.*pBVP.Js(ns,:),'-k','Linewidth',1.2); hold on
% plot(Z./Z(end),c.Wchannel.*pBVP.Jw(ns,:),'--k','Linewidth',1.2)

% xlabel('z L^{-1}  /  -'); ylabel('T  /  K'); legend('Concentrate','Dilute','Location','East'); legend boxoff
% xlabel('z L^{-1}  /  -'); ylabel('J  /  mol m^{-1}s^{-1}'); legend('J_s','J_w','Location','East'); legend boxoff
% exportgraphics(gcf,'JProfile.png','Resolution',300)






%%
% subplot(1,2,1)
% plot(Z./Z(end), precip.m_c(ns,:),'k-','LineWidth',1.2); hold on;
% plot(Z./Z(end), precip.m_d(ns,:),'k--','LineWidth',1.2); 
% legend('Concentrate channel','Dilute channel','location','east'); legend boxoff
% set(gca,'FontSize',14,'linewidth',1.2);
% xlabel('Z L^{-1}  /  -'); ylabel('m  /  mol kg^{-1}')
% 
% subplot(1,2,2)
% plot(Z./Z(end), precip.F_wc(ns,:).*1e3,'k-','LineWidth',1.2); hold on; 
% plot(Z./Z(end), precip.F_wd(ns,:).*1e3,'k--','LineWidth',1.2); 
% legend('Concentrate channel','Dilute channel','location','northwest'); legend boxoff
% set(gca,'FontSize',14,'linewidth',1.2);
% xlabel('Z L^{-1}  /  -'); ylabel('F_w  /  g s^{-1}')
% 
% set(gcf, 'Position', [0 50 1.1*1080 0.6*720])
% exportgraphics(gcf,'CellProfiles.png','Resolution',300)